; **********************************************************
 ;  Progetto videogioco WASH MAN (C) DreamQuick Studio 2016
 ; *********************************************************
 ;  WASH MAN v0.58 by AGsoftware 2016
 ;  MODE2IN1.BIN v1.0 by DanySoft
 ; *********************************************************
 ;  Definizione caratteri multicolore e sprites
 ; *********************************************************
 ;  Con modalit BITMAP SCREEN2 in SCREEN1 multicolors
 ; *********************************************************



 .org $C000 - 7

 .db $fe
 .dw startProgram,endProgram,startProgram

startProgram:    

LDIRVM .equ $005c ; routine del BIOS usata per riempire la VRAM
CHGMOD .equ $005f ; routine del BIOS usata per inizializzare lo schermo 
;(V9938)

CHRTBL1 .equ $0100 ; indirizzi tabelle delle forme +32*8
CHRTBL2 .equ $0900
CHRTBL3 .equ $1100

CLRTBL1 .equ $2100 ; indirizzi tabelle del colore +32*8
CLRTBL2 .equ $2900
CLRTBL3 .equ $3100

QTYFONT .equ $0300 ; 96*8 = 96 font

SPRTBL .equ $3800 ; indirizzi tabelle definizione sprites
SPRCLR .equ $1B00 ; indirizzi tabelle colore per sprites scr1



 ; Inizializza i registri del VDP.
writeVDP:

 di
 push af
 push bc
 push de
 push hl



 call $cc ; key off
 

 ;ld a,15 ; colore primo piano(scritte)
 ;ld ($f3e9),a ; indirizzo primo piano(scritte)
 ;ld a,1 ; colore sfondo
 ;ld ($f3ea),a ; indirizzo sfondo


 ld ix,$F3E9
 ld (ix+0),15	; colore primo piano
 ld (ix+1),1	; colore sfondo schermo
 ld (ix+2),1	; colore bordo dello schermo
 call $62		; chiama alla bios rom

;M1 M2 M3 M4 M5  Screen format
;1  0  0  0  0   Text                            (BASIC SCREEN 0)
;0  0  0  0  0   Half text                       (BASIC SCREEN 1)
;0  0  1  0  0   Hi resolution                   (BASIC SCREEN 2)
;0  1  0  0  0   Multicolour                     (BASIC SCREEN 3)
;0  0  0  1  0   Scrn2 with 8 Sprites/Line       (BASIC SCREEN 4)
;0  0  1  1  0   256*212, 16  colours/pixel      (BASIC SCREEN 5)
;0  0  0  0  1   512*212, 4   colours/pixel      (BASIC SCREEN 6)
;0  0  1  0  1   512*212, 16  colours/pixel      (BASIC SCREEN 7)
;0  0  1  1  1   256*212, 256 colours/pixel      (BASIC SCREEN 8)
;1  0  0  1  0   80 column text screen           (BASIC SCREEN0, WIDTH 80)

;Register 0:
;Mode register 0
;bit  Name  Expl.
;0    D     External video input (0=input disable, 1=enable)
;1    M3    Mode M3
;2    M4    Mode M4 (Not on MSX 1)
;3    M5    Mode M5 (Not on MSX 1)
;4    IE1   Horizontal Retrace Interrupt Enable
;5    IE0   Vertical Retrace Interrupt Enable
;6    DG    DiGitize mode
;7    0     Always 0

;Register 1:
;Mode register 1
;bit  Name  Expl.
;0    MAG   Sprite zoom          (0=x1, 1=x2)
;1    SZ    Sprite size          (0=8x8, 1=16x16)
;2    0     Always 0 on MSX 1
;3    M2    Mode M2
;4    M1    Mode M1
;5    IE2   Interrupt control (50Hz (PAL),
;           60 Hz (NTSC) and Light pen/mouse on
;           MVDP colour bus)             (0=Disable, 1=Enable)
;6    BLK   Screen output control        (0=Disable, 1=Enable)
;7    416   VRAM size control            (0=4K, 1=16K)



 ld a,1
 call CHGMOD  ; SCREEN1   
 
 LD HL,$F3B0 ; INDIRIZZO PER WIDTH (numero delle colonne da basic) 
 LD A,32     ; valore per 32 colonne full screen1
 LD (HL),A

;  ld a,1	;screen 1
;  call CHGMOD

 ; VDP(0)=4
 ld a,2
 out ($99),a
 ld a, 0
 or 128
 out ($99),a

 ; SCREEN,2 = VDP(1)=98 = SPRITE16X16
 ld a,98 ;224 ?
 out ($99),a
 ld a,1
 or 128	
 out ($99),a

 ; VDP(4)=3
 ld a,3
 out ($99),a
 ld a,4+128
 out ($99),a

 ; VDP(3)=255
 ld a,255
 out ($99),a
 ld a,3+128
 out ($99),a

 ; VDP(5)=63 for screen 4
 ; VDP(5)=54 for screen 1,2 !!!

 ld a,54
 out ($99),a
 ld a,5
 or 128
 out ($99),a

 ; Imposta la forma dei font
 ld hl,FONT_TBL
 ld de,CHRTBL1
 ld bc,QTYFONT
 call LDIRVM
 ld hl,FONT_TBL
 ld de,CHRTBL2
 ld bc,QTYFONT
 call LDIRVM
 ld hl,FONT_TBL
 ld de,CHRTBL3
 ld bc,QTYFONT
 call LDIRVM

 ; Imposta la tabella colore dei font
 ld hl,COLOR_TBL
 ld de,CLRTBL1
 ld bc,QTYFONT
 call LDIRVM
 ld hl,COLOR_TBL
 ld de,CLRTBL2
 ld bc,QTYFONT
 call LDIRVM
 ld hl,COLOR_TBL
 ld de,CLRTBL3
 ld bc,QTYFONT
 call LDIRVM

; Alloca la forma: 1UP carattere vite in tabella ASCII
 ld hl,LIVES_1UP
 ld de,CHRTBL1+(126*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,LIVES_1UP
 ld de,CHRTBL2+(126*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,LIVES_1UP
 ld de,CHRTBL3+(126*8)-$100
 ld bc,8
 call LDIRVM

; Alloca il colore: 1UP carattere vite in tabella ASCII
 ld hl,LIVES_1UP_COLOR
 ld de,CLRTBL1+(126*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,LIVES_1UP_COLOR
 ld de,CLRTBL2+(126*8)-$100
 ld bc,8 
 call LDIRVM
 ld hl,LIVES_1UP_COLOR
 ld de,CLRTBL3+(126*8)-$100
 ld bc,8
 call LDIRVM

; Alloca la forma: WALL BASIC in tabella ASCII
 ld hl,WALLBASIC
 ld de,CHRTBL1+(128*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,WALLBASIC
 ld de,CHRTBL2+(128*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,WALLBASIC
 ld de,CHRTBL3+(128*8)-$100
 ld bc,8
 call LDIRVM

; Alloca il colore: WALL BASIC in tabella ASCII
 ld hl,WALLBASIC_COLOR
 ld de,CLRTBL1+(128*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,WALLBASIC_COLOR
 ld de,CLRTBL2+(128*8)-$100
 ld bc,8 
 call LDIRVM
 ld hl,WALLBASIC_COLOR
 ld de,CLRTBL3+(128*8)-$100
 ld bc,8
 call LDIRVM

; Alloca la forma di: BRICKS MATTONI in tabella ASCII
 ld hl,BRICKS
 ld de,CHRTBL1+(129*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,BRICKS
 ld de,CHRTBL2+(129*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,BRICKS
 ld de,CHRTBL3+(129*8)-$100
 ld bc,2*8
 call LDIRVM

; Alloca il colore di: BRICKS MATTONI in tabella ASCII
 ld hl,BRICKS_COLOR
 ld de,CLRTBL1+(129*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,BRICKS_COLOR
 ld de,CLRTBL2+(129*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,BRICKS_COLOR
 ld de,CLRTBL3+(129*8)-$100
 ld bc,2*8
 call LDIRVM   

; Alloca la forma: WASH MACHINE 1 e 2 lavatrice 1 in tabella ASCII
 ld hl,WASHMACHINES
 ld de,CHRTBL1+(131*8)-$100
 ld bc,8*8
 call LDIRVM
 ld hl,WASHMACHINES
 ld de,CHRTBL2+(131*8)-$100
 ld bc,8*8
 call LDIRVM
 ld hl,WASHMACHINES
 ld de,CHRTBL3+(131*8)-$100
 ld bc,8*8
 call LDIRVM

; Alloca il colore: WASH MACHINE 1 e 2 lavatrice 2 in tabella ASCII
 ld hl,WASHMACHINES_COLOR
 ld de,CLRTBL1+(131*8)-$100
 ld bc,8*8
 call LDIRVM
 ld hl,WASHMACHINES_COLOR
 ld de,CLRTBL2+(131*8)-$100
 ld bc,8*8
 call LDIRVM
 ld hl,WASHMACHINES_COLOR
 ld de,CLRTBL3+(131*8)-$100
 ld bc,8*8
 call LDIRVM
     
;Alloca la forma di: ENGINE LIFT (motore ascensore) in tabella ASCII
 ld hl,ENGINELIFT
 ld de,CHRTBL1+(139*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,ENGINELIFT
 ld de,CHRTBL2+(139*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,ENGINELIFT
 ld de,CHRTBL3+(139*8)-$100
 ld bc,2*8
 call LDIRVM

;Alloca il colore di: ENGINE LIFT (motore ascensore) in tabella ASCII
 ld hl,ENGINELIFT_COLOR
 ld de,CLRTBL1+(139*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,ENGINELIFT_COLOR
 ld de,CLRTBL2+(139*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,ENGINELIFT_COLOR
 ld de,CLRTBL3+(139*8)-$100
 ld bc,2*8
 call LDIRVM          
  
; Alloca la forma di: CORDE LIFT ascensore in tabella ASCII
 ld hl,CORDELIFT
 ld de,CHRTBL1+(141*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,CORDELIFT
 ld de,CHRTBL2+(141*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,CORDELIFT
 ld de,CHRTBL3+(141*8)-$100
 ld bc,2*8
 call LDIRVM

; Alloca il colore di: CORDE LIFT ascensore in tabella ASCII
 ld hl,CORDELIFT_COLOR
 ld de,CLRTBL1+(141*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,CORDELIFT_COLOR
 ld de,CLRTBL2+(141*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,CORDELIFT_COLOR
 ld de,CLRTBL3+(141*8)-$100
 ld bc,2*8
 call LDIRVM          
 
; Alloca la forma di: DOOR ROOM TOP (porta TOP scritta ROOM) in tabella ASCII
 ld hl,DOORROOMTOP
 ld de,CHRTBL1+(143*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,DOORROOMTOP
 ld de,CHRTBL2+(143*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,DOORROOMTOP
 ld de,CHRTBL3+(143*8)-$100
 ld bc,2*8
 call LDIRVM

; Alloca il colore di: DOOR ROOM TOP (porta TOP scritta ROOM) in tabella ASCII
 ld hl,DOORROOMTOP_COLOR
 ld de,CLRTBL1+(143*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,DOORROOMTOP_COLOR
 ld de,CLRTBL2+(143*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,DOORROOMTOP_COLOR
 ld de,CLRTBL3+(143*8)-$100
 ld bc,2*8
 call LDIRVM   
 
; Alloca la forma di: DOOR ROOM (porta stanza base) in tabella ASCII
 ld hl,DOORROOM
 ld de,CHRTBL1+(145*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,DOORROOM
 ld de,CHRTBL2+(145*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,DOORROOM
 ld de,CHRTBL3+(145*8)-$100
 ld bc,4*8
 call LDIRVM

; Alloca il colore di: DOOR ROOM (porta stanza base) in tabella ASCII
 ld hl,DOORROOM_COLOR
 ld de,CLRTBL1+(145*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,DOORROOM_COLOR
 ld de,CLRTBL2+(145*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,DOORROOM_COLOR
 ld de,CLRTBL3+(145*8)-$100
 ld bc,4*8
 call LDIRVM   
 
;Alloca la forma di: UMBRELLA (ombrello) in tabella ASCII
 ld hl,UMBRELLA
 ld de,CHRTBL1+(149*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,UMBRELLA
 ld de,CHRTBL2+(149*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,UMBRELLA
 ld de,CHRTBL3+(149*8)-$100
 ld bc,4*8
 call LDIRVM

;Alloca il colore di: UMBRELLA (ombrello) in tabella ASCII
 ld hl,UMBRELLA_COLOR
 ld de,CLRTBL1+(149*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,UMBRELLA_COLOR
 ld de,CLRTBL2+(149*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,UMBRELLA_COLOR
 ld de,CLRTBL3+(149*8)-$100
 ld bc,4*8
 call LDIRVM   
 
;Alloca la forma di: MATTONE GREZZO (contorno per grande stanza) in tabella ASCII
 ld hl,MATTONEGREZZO
 ld de,CHRTBL1+(154*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,MATTONEGREZZO
 ld de,CHRTBL2+(154*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,MATTONEGREZZO
 ld de,CHRTBL3+(154*8)-$100
 ld bc,2*8
 call LDIRVM

;Alloca il colore di: MATTONE GREZZO (contorno per grande stanza) in tabella ASCII
 ld hl,MATTONEGREZZO_COLOR
 ld de,CLRTBL1+(154*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,MATTONEGREZZO_COLOR
 ld de,CLRTBL2+(154*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,MATTONEGREZZO_COLOR
 ld de,CLRTBL3+(154*8)-$100
 ld bc,2*8
 call LDIRVM   

; Alloca la forma di: WALL BACKGROUND (mattone di base per sfondo) in tabella ASCII
 ld hl,WALLBACKGROUND
 ld de,CHRTBL1+(156*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,WALLBACKGROUND
 ld de,CHRTBL2+(156*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,WALLBACKGROUND
 ld de,CHRTBL3+(156*8)-$100
 ld bc,8
 call LDIRVM

; Alloca il colore di: WALL BACKGROUND (mattone di base per sfondo) in tabella ASCII
 ld hl,WALLBACKGROUND_COLOR
 ld de,CLRTBL1+(156*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,WALLBACKGROUND_COLOR
 ld de,CLRTBL2+(156*8)-$100
 ld bc,8
 call LDIRVM
 ld hl,WALLBACKGROUND_COLOR
 ld de,CLRTBL3+(156*8)-$100
 ld bc,8
 call LDIRVM         

; Alloca la forma di: INTERNO LIFT ASCENSORE in tabella ASCII
 ld hl,INTERNOLIFT
 ld de,CHRTBL1+(157*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,INTERNOLIFT
 ld de,CHRTBL2+(157*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,INTERNOLIFT
 ld de,CHRTBL3+(157*8)-$100
 ld bc,4*8
 call LDIRVM

; Alloca il colore di: INTERNO LIFT ASCENSORE colore GIALLO in tabella ASCII
 ld hl,INTERNOLIFT_COLOR
 ld de,CLRTBL1+(157*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,INTERNOLIFT_COLOR
 ld de,CLRTBL2+(157*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,INTERNOLIFT_COLOR
 ld de,CLRTBL3+(157*8)-$100
 ld bc,4*8
 call LDIRVM  
 

; Alloca la forma di: DOOR BIG ROOM TOP STANZA INTERNA in tabella ASCII
 ld hl,DOORBIGROOMTOP
 ld de,CHRTBL1+(161*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,DOORBIGROOMTOP
 ld de,CHRTBL2+(161*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,DOORBIGROOMTOP
 ld de,CHRTBL3+(161*8)-$100
 ld bc,2*8
 call LDIRVM

; Alloca il colore di: DOOR BIG ROOM TOP STANZA INTERNA 
; colore GIALLO in tabella ASCII
 ld hl,DOORBIGROOMTOP_COLOR
 ld de,CLRTBL1+(161*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,DOORBIGROOMTOP_COLOR
 ld de,CLRTBL2+(161*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,DOORBIGROOMTOP_COLOR
 ld de,CLRTBL3+(161*8)-$100
 ld bc,2*8
 call LDIRVM   

; Alloca la forma di: DOOR EXIT BIG ROOM STANZA INTERNA in tabella ASCII
 ld hl,DOORBIGROOM
 ld de,CHRTBL1+(163*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,DOORBIGROOM
 ld de,CHRTBL2+(163*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,DOORBIGROOM
 ld de,CHRTBL3+(163*8)-$100
 ld bc,4*8
 call LDIRVM

; Alloca il colore di: DOOR EXIT BIG ROOM STANZA INTERNA 
; colore GIALLO MULTICOLORE in tabella ASCII
 ld hl,DOORBIGROOM_COLOR
 ld de,CLRTBL1+(163*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,DOORBIGROOM_COLOR
 ld de,CLRTBL2+(163*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,DOORBIGROOM_COLOR
 ld de,CLRTBL3+(163*8)-$100
 ld bc,4*8
 call LDIRVM   
 
; Alloca la forma di: MAGLIETTA VESTITO in tabella ASCII
 ld hl,MAGLIETTA
 ld de,CHRTBL1+(167*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,MAGLIETTA
 ld de,CHRTBL2+(167*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,MAGLIETTA
 ld de,CHRTBL3+(167*8)-$100
 ld bc,4*8
 call LDIRVM

; Alloca il colore di: MAGLIETTA VESTITO 
; colore ROSSO CHIARO MULTICOLORE in tabella ASCII
 ld hl,MAGLIETTA_COLOR
 ld de,CLRTBL1+(167*8)-$100                                                         
 ld bc,4*8
 call LDIRVM
 ld hl,MAGLIETTA_COLOR
 ld de,CLRTBL2+(167*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,MAGLIETTA_COLOR
 ld de,CLRTBL3+(167*8)-$100
 ld bc,4*8
 call LDIRVM   

; Alloca la forma di: PANTALONI VESTITO in tabella ASCII
 ld hl,PANTALONI
 ld de,CHRTBL1+(171*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,PANTALONI
 ld de,CHRTBL2+(171*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,PANTALONI
 ld de,CHRTBL3+(171*8)-$100
 ld bc,4*8
 call LDIRVM

; Alloca il colore di: PANTALONI VESTITO 
; colore AZZURRO MULTICOLORE in tabella ASCII
 ld hl,PANTALONI_COLOR
 ld de,CLRTBL1+(171*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,PANTALONI_COLOR
 ld de,CLRTBL2+(171*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,PANTALONI_COLOR
 ld de,CLRTBL3+(171*8)-$100
 ld bc,4*8
 call LDIRVM   
 
; Alloca la forma di: COLONNA in tabella ASCII 
; per 4 caratteri
 ld hl,COLONNA
 ld de,CHRTBL1+(175*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,COLONNA
 ld de,CHRTBL2+(175*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,COLONNA
 ld de,CHRTBL3+(175*8)-$100
 ld bc,4*8
 call LDIRVM

; Alloca il colore di: COLONNA colore grigio in tabella ASCII 
; per 4 caratteri
 ld hl,COLONNA_COLOR
 ld de,CLRTBL1+(175*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,COLONNA_COLOR
 ld de,CLRTBL2+(175*8)-$100
 ld bc,4*8
 call LDIRVM
 ld hl,COLONNA_COLOR
 ld de,CLRTBL3+(175*8)-$100
 ld bc,4*8
 call LDIRVM    
 
; Alloca la forma di: MINI MOUSE PORTA in tabella ASCII 
; per 2 caratteri
 ld hl,MINIMOUSE
 ld de,CHRTBL1+(179*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,MINIMOUSE
 ld de,CHRTBL2+(179*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,MINIMOUSE
 ld de,CHRTBL3+(179*8)-$100
 ld bc,2*8
 call LDIRVM

; Alloca il colore di: MINI MOUSE PORTA colore grigio in tabella ASCII 
; per 2 caratteri
 ld hl,MINIMOUSE_COLOR
 ld de,CLRTBL1+(179*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,MINIMOUSE_COLOR
 ld de,CLRTBL2+(179*8)-$100
 ld bc,2*8
 call LDIRVM
 ld hl,MINIMOUSE_COLOR
 ld de,CLRTBL3+(179*8)-$100
 ld bc,2*8
 call LDIRVM    
       
; Alloca la forma di: ANIMAZIONE PORTA in tabella ASCII 
; per 16 caratteri
 ld hl,ANIMAZIONE_PORTA
 ld de,CHRTBL1+(181*8)-$100
 ld bc,16*8
 call LDIRVM
 ld hl,ANIMAZIONE_PORTA
 ld de,CHRTBL2+(181*8)-$100
 ld bc,16*8
 call LDIRVM
 ld hl,ANIMAZIONE_PORTA
 ld de,CHRTBL3+(181*8)-$100
 ld bc,16*8
 call LDIRVM

; Alloca il colore di: ANIMAZIONE PORTA colore VERDE N.2 in tabella ASCII 
; per 16 caratteri
 ld hl,ANIMAZIONE_PORTA_COLOR
 ld de,CLRTBL1+(181*8)-$100
 ld bc,16*8
 call LDIRVM
 ld hl,ANIMAZIONE_PORTA_COLOR
 ld de,CLRTBL2+(181*8)-$100
 ld bc,16*8
 call LDIRVM
 ld hl,ANIMAZIONE_PORTA_COLOR
 ld de,CLRTBL3+(181*8)-$100
 ld bc,16*8
 call LDIRVM    
 
 
 
; Alloca la forma degli sprite
 ld hl,SPRDEF
 ld de,SPRTBL
 ld bc,32*36
 call LDIRVM 

;
 ld a,$6A
 ld hl,$27F8	;255x8 redraw giallo "COLORE CURSORE"
 ld bc,8
 call $56
 
 ld a,$6a
 ld hl,$2FF8
 ld bc,8
 call $56
 
 ld a,$6a
 ld hl,$37F8
 ld bc,8
 call $56
;
 pop hl
 pop de
 pop bc
 pop af
 ei
 ret ; torna al basic


FONT_TBL:
 ; Forma font 1o Set
 .db 000h,000h,000h,000h,000h,000h,000h,000h,018h,03Ch,03Ch,03Ch,018h,000h,018h,000h
 .db 06Ch,06Ch,048h,000h,000h,000h,000h,000h,06Ch,0FEh,06Ch,06Ch,06Ch,0FEh,06Ch,000h
 .db 018h,03Eh,058h,03Ch,01Ah,07Ch,018h,000h,000h,0C6h,0CCh,018h,030h,066h,0C6h,000h
 .db 070h,0C8h,0C8h,070h,09Ah,08Ch,076h,000h,018h,018h,010h,000h,000h,000h,000h,000h

 .db 00Ch,018h,030h,030h,030h,018h,00Ch,000h,030h,018h,00Ch,00Ch,00Ch,018h,030h,000h
 .db 000h,018h,05Ah,03Ch,03Ch,05Ah,018h,000h,000h,018h,018h,07Eh,018h,018h,000h,000h
 .db 000h,000h,000h,000h,018h,018h,008h,010h,000h,000h,000h,07Ch,000h,000h,000h,000h
 .db 000h,000h,000h,000h,000h,018h,018h,000h,000h,006h,00Ch,018h,030h,060h,0C0h,000h

 .db 038h,04Ch,0C6h,0C6h,0C6h,064h,038h,000h,018h,038h,018h,018h,018h,018h,07Eh,000h
 .db 07Ch,0C6h,00Eh,03Ch,078h,0E0h,0FEh,000h,07Eh,00Ch,018h,03Ch,006h,0C6h,07Ch,000h
 .db 01Ch,03Ch,06Ch,0CCh,0FEh,00Ch,00Ch,000h,0FCh,0C0h,0FCh,006h,006h,0C6h,07Ch,000h
 .db 03Ch,060h,0C0h,0FCh,0C6h,0C6h,07Ch,000h,0FEh,0C6h,00Ch,018h,030h,030h,030h,000h

 .db 07Ch,0C6h,0C6h,07Ch,0C6h,0C6h,07Ch,000h,07Ch,0C6h,0C6h,07Eh,006h,00Ch,078h,000h
 .db 000h,018h,018h,000h,018h,018h,000h,000h,000h,018h,018h,000h,018h,018h,008h,010h
 .db 00Ch,018h,030h,060h,030h,018h,00Ch,000h,000h,000h,07Ch,000h,07Ch,000h,000h,000h
 .db 060h,030h,018h,00Ch,018h,030h,060h,000h,07Ch,0C6h,006h,01Ch,030h,000h,030h,000h

 .db 03Ch,042h,099h,0A1h,0A1h,099h,042h,03Ch,038h,06Ch,0C6h,0C6h,0FEh,0C6h,0C6h,000h
 .db 0FCh,0C6h,0C6h,0FCh,0C6h,0C6h,0FCh,000h,03Ch,066h,0C0h,0C0h,0C0h,066h,03Ch,000h
 .db 0F8h,0CCh,0C6h,0C6h,0C6h,0CCh,0F8h,000h,0FEh,0C0h,0C0h,0F8h,0C0h,0C0h,0FEh,000h
 .db 0FEh,0C0h,0C0h,0F8h,0C0h,0C0h,0C0h,000h,03Eh,060h,0C0h,0CEh,0C6h,066h,03Eh,000h

 .db 0C6h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,000h,07Eh,018h,018h,018h,018h,018h,07Eh,000h
 .db 006h,006h,006h,006h,006h,0C6h,07Ch,000h,0C6h,0CCh,0D8h,0F0h,0F8h,0DCh,0CEh,000h
 .db 0C0h,0C0h,0C0h,0C0h,0C0h,0C0h,0FEh,000h,0C6h,0EEh,0FEh,0FEh,0D6h,0C6h,0C6h,000h
 .db 0C6h,0E6h,0F6h,0FEh,0DEh,0CEh,0C6h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h

 .db 0FCh,0C6h,0C6h,0C6h,0FCh,0C0h,0C0h,000h,07Ch,0C6h,0C6h,0C6h,0DEh,0CCh,076h,000h
 .db 0FCh,0C6h,0C6h,0CEh,0F8h,0DCh,0CEh,000h,078h,0CCh,0C0h,07Ch,006h,0C6h,07Ch,000h
 .db 07Eh,018h,018h,018h,018h,018h,018h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h
 .db 0C6h,0C6h,0C6h,0EEh,07Ch,038h,010h,000h,0C6h,0C6h,0D6h,0FEh,0FEh,06Ch,044h,000h

 .db 0C6h,0EEh,07Ch,038h,07Ch,0EEh,0C6h,000h,066h,066h,066h,03Ch,018h,018h,018h,000h
 .db 0FEh,00Eh,01Ch,038h,070h,0E0h,0FEh,000h,0F8h,0C0h,0C0h,0C0h,0C0h,0C0h,0F8h,000h
 .db 000h,080h,040h,020h,010h,008h,000h,000h,0F8h,018h,018h,018h,018h,018h,0F8h,000h
 .db 000h,000h,020h,050h,088h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,0F8h

 ; Forma font 2o Set
 .db 03ch,042h,099h,0a1h,0a1h,099h,042h,03ch,038h,06ch,0c6h,0c6h,0feh,0c6h,0c6h,000h
 .db 0fch,0c6h,0c6h,0fch,0c6h,0c6h,0fch,000h,03ch,066h,0c0h,0c0h,0c0h,066h,03ch,000h
 .db 0f8h,0cch,0c6h,0c6h,0c6h,0cch,0f8h,000h,0feh,0c0h,0c0h,0f8h,0c0h,0c0h,0feh,000h
 .db 0feh,0c0h,0c0h,0f8h,0c0h,0c0h,0c0h,000h,03eh,060h,0c0h,0ceh,0c6h,066h,03eh,000h

 .db 0c6h,0c6h,0c6h,0feh,0c6h,0c6h,0c6h,000h,07eh,018h,018h,018h,018h,018h,07eh,000h
 .db 006h,006h,006h,006h,006h,0c6h,07ch,000h,0c6h,0cch,0d8h,0f0h,0f8h,0dch,0ceh,000h
 .db 0c0h,0c0h,0c0h,0c0h,0c0h,0c0h,0feh,000h,0c6h,0eeh,0feh,0feh,0d6h,0c6h,0c6h,000h
 .db 0c6h,0e6h,0f6h,0feh,0deh,0ceh,0c6h,000h,07ch,0c6h,0c6h,0c6h,0c6h,0c6h,07ch,000h
                                                                           
 .db 0fch,0c6h,0c6h,0c6h,0fch,0c0h,0c0h,000h,07ch,0c6h,0c6h,0c6h,0deh,0cch,076h,000h
 .db 0fch,0c6h,0c6h,0ceh,0f8h,0dch,0ceh,000h,078h,0cch,0c0h,07ch,006h,0c6h,07ch,000h
 .db 07eh,018h,018h,018h,018h,018h,018h,000h,0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,07ch,000h
 .db 0c6h,0c6h,0c6h,0eeh,07ch,038h,010h,000h,0c6h,0c6h,0d6h,0feh,0feh,06ch,044h,000h
                                                                           
 .db 0c6h,0eeh,07ch,038h,07ch,0eeh,0c6h,000h,066h,066h,066h,03ch,018h,018h,018h,000h
 .db 0feh,00eh,01ch,038h,070h,0e0h,0feh,000h,0f8h,0c0h,0c0h,0c0h,0c0h,0c0h,0f8h,000h
 .db 000h,080h,040h,020h,010h,008h,000h,000h,0f8h,018h,018h,018h,018h,018h,0f8h,000h
 .db 000h,000h,020h,050h,088h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,0f8h
                                                                           
COLOR_TBL:

 ; Colore font 1o Set (sfumatura blu)
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h

 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h

 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h

 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h

 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h

 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h

 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h

 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h
 .db 040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h,040h,050h,070h,070h,0f0h,0f0h,0f0h,0f0h

 ; Colore font 2o Set (sfumatura rossa)
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h

 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h

 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h

 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h
 .db 060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h,060h,080h,090h,090h,0f0h,0f0h,0f0h,0f0h

; Altri oggetti allocabili in tabella ASCII

LIVES_1UP:
  .DB 112,252,250,232,252,252,120,112
LIVES_1UP_COLOR:  ; pink multicolor 
  .DB  80,80,80,208,208,208,208,80
WALLBASIC:
  .DB 0,251,251,251,0,127,127,127
WALLBASIC_COLOR:  ; green multicolor
  .DB 206,206,62,62,206,206,62,62

; BRICKS (MATTONI)
BRICKS:
  .DB $15,$00,$55,$0A,$55,$2A,$15,$00
  .DB $54,$AA,$54,$AA,$5E,$AE,$FC,$00
BRICKS_COLOR:
  .DB 96,96,96,96,96,96,96,96
  .DB 96,96,96,96,96,96,96,96
; WASH MACHINES
WASHMACHINES:
; WASH MACHINE 1
  .DB $3F,$55,$AA,$FF,$8D,$FD,$8D,$FF
  .DB $E0,$DF,$BF,$BF,$BF,$DF,$E0,$FF
  .DB $FF,$55,$AB,$FD,$5B,$7D,$5B,$FD
  .DB $7B,$BD,$DB,$DD,$DB,$BD,$7A,$FC
; WASH MACHINE 2
  .DB $3F,$55,$AA,$FF,$8D,$FD,$8D,$FF
  .DB $E0,$CA,$94,$A8,$80,$C0,$E0,$FF
  .DB $FF,$55,$AB,$FD,$5B,$7D,$5B,$FD
  .DB $7B,$3D,$1B,$1D,$1B,$3D,$7A,$FC 
WASHMACHINES_COLOR:
; WASHMACHINE 1
  .DB 95,95,95,95,95,95,95,95,95,95,95,95,95,95,95,95
  .DB 95,95,95,95,95,95,95,95,95,95,95,95,95,95,95,95
; WASHMACHINE 2 
  .DB 159,159,159,159,159,159,159,159,159,159,159,159,159,159,159,159
  .DB 159,159,159,159,159,159,159,159,159,159,159,159,159,159,159,159
; ENGINE LIFT (motore ascensore)
ENGINELIFT:
  .DB $00,$3F,$62,$7E,$62,$7E,$3F,$08
  .DB $00,$F8,$BC,$A4,$A4,$BC,$F8,$10
ENGINELIFT_COLOR:
  .DB 64,64,64,64,64,64,64,64
  .DB 64,64,64,64,64,64,64,64
; Corde LIFT ascensore 
CORDELIFT:
  .DB $08,$08,$08,$08,$08,$08,$08,$08
  .DB $10,$10,$10,$10,$10,$10,$10,$10
; colore Corde LIFT ascensore
CORDELIFT_COLOR:
  .DB 64,64,64,64,64,64,64,64
  .DB 64,64,64,64,64,64,64,64
; DOOR ROOM TOP (Porta stanza TOP scritta ROOM)
DOORROOMTOP:
  .DB $1F,$30,$7B,$FF,$18,$6A,$1A,$68
  .DB $F8,$0C,$DE,$FF,$8A,$A8,$AA,$8A
; DOOR ROOM TOP COLOR
DOORROOMTOP_COLOR:
   .DB 207,207,207,207,207,207,207,207
   .DB 207,207,207,207,207,207,207,207
; DOOR ROOM (porta stanza)
DOORROOM:
  .DB $FF,$00,$FF,$FF,$00,$FF,$FF,$01
  .DB $FF,$FF,$01,$FF,$FF,$00,$FF,$FF
  .DB $FF,$00,$FF,$FF,$00,$FF,$FF,$F8
  .DB $1F,$4F,$08,$FF,$FF,$00,$FF,$FF
; DOOR ROOM COLOR
DOORROOM_COLOR:
  .DB 43,43,43,43,43,43,43,43
  .DB 43,43,43,43,43,43,43,43
  .DB 43,43,43,43,43,43,43,43
  .DB 43,43,43,43,43,43,43,43
; UMBRELLA (ombrello)
UMBRELLA:
  .DB 0,1,7,11,21,43,127,255,147,1,1,1,1,1,1,0
  .DB 0,128,224,208,168,212,254,255,145,0,0,0,0,0,32,192
; UMBRELLA COLOR (ombrello colore giallo)
UMBRELLA_COLOR:
  .DB 160,160,160,160,160,160,160,160,160,160,160,160,160,160,160,160  
  .DB 160,160,160,160,160,160,160,160,160,160,160,160,160,160,160,160  
; MATTONE GREZZO
MATTONEGREZZO:
  .DB $FF,$89,$FE,$DF,$FB,$EF,$DF,$00
  .DB $FE,$EE,$D2,$FE,$FE,$BE,$16,$00
; MATTONE GREZZO COLORE
MATTONEGREZZO_COLOR:
  .DB 96,96,96,96,96,96,96,96
  .DB 96,96,96,96,96,96,96,96  
; Sfondo muro di base per stanza
WALLBACKGROUND:
  .DB $FF,$04,$04,$04,$FF,$80,$80,$80
; Sfondo muro di base per stanza
WALLBACKGROUND_COLOR:  
  .DB 224,224,224,224,224,224,224,224
; INTERNO LIFT ASCENSORE
INTERNOLIFT:
  .DB $DF,$DF,$DF,$DF,$DF,$DF,$DF,$DF
  .DB $DF,$DF,$DF,$DF,$C0,$BF,$7F,$FF
  .DB $FB,$FB,$FB,$FB,$FB,$FB,$FB,$FB
  .DB $FB,$FB,$FB,$FB,$03,$FD,$FE,$FF
; INTERNO LIFT ASCENSORE COLORE GIALLO Codice 10
INTERNOLIFT_COLOR:  
  .DB 175,175,175,175,175,175,175,175,175,175,175,175,175,175,175,175
  .DB 175,175,175,175,175,175,175,175,175,175,175,175,175,175,175,175
; porta top(parte alta) grande stanza interna colore giallo
DOORBIGROOMTOP:
  .DB 1,3,15,63,127,127,255,255
  .DB 128,192,240,252,254,254,255,255
DOORBIGROOMTOP_COLOR:
  .DB 160,160,160,160,160,160,160,160
  .DB 160,160,160,160,160,160,160,160
; porta EXIT grande stanza interna colore giallo multicolore
DOORBIGROOM:      
  .DB 255,128,233,137,198,134,137,233,128,206,170,202,170,174,128,255
  .DB 255,1,93,73,73,73,73,73,1,235,175,171,171,235,1,255
DOORBIGROOM_COLOR:
  .DB 175,175,175,175,175,175,175,175,175,175,175,175,175,175,175,175
  .DB 175,175,175,175,175,175,175,175,175,175,175,175,175,175,175,175
; maglietta vestito colore rosso chiaro multicolore
MAGLIETTA:
  .DB 0,0,0,28,62,111,207,15,15,15,15,15,0,0,0,0
  .DB 0,0,0,56,124,246,243,240,240,240,240,240,0,0,0,0
MAGLIETTA_COLOR:
  .DB 0,0,0,144,144,144,144,96,144,96,144,144,0,0,0,0
  .DB 0,0,0,144,144,144,144,96,144,96,144,144,0,0,0,0     
PANTALONI:
  .DB 0,0,0,0,0,0,7,7,7,7,14,12,28,56,0,0
  .DB 0,0,0,0,0,0,224,224,224,224,112,48,56,28,0,0
PANTALONI_COLOR:
  .DB 0,0,0,0,0,0,80,96,80,80,80,80,96,80,0,0
  .DB 0,0,0,0,0,0,80,96,80,80,80,80,96,80,0,0
COLONNA:
; --- Slot 0
; color 6
  .DB $01,$02,$01,$02,$01,$02,$03,$03
  .DB $40,$C0,$40,$C0,$C0,$C0,$C0,$C0
;
; --- Slot 2
; color 6
  .DB $03,$03,$03,$03,$03,$07,$0F,$0F
  .DB $C0,$C0,$C0,$C0,$C0,$E0,$F0,$F0
COLONNA_COLOR:
  .DB 96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96
  .DB 96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96
MINIMOUSE:
; topo che appare sulle parte del palazzo
; appare in verticale
; color 14
  .DB $0E,$DF,$FF,$FF,$FE,$C8,$FC,$BC
  .DB $FC,$C8,$FE,$FF,$FF,$DF,$0E,$00
MINIMOUSE_COLOR:
  .DB 224,224,224,224,224,224,224,224
  .DB 224,224,224,224,224,224,224,224
ANIMAZIONE_PORTA:
; animazione porte del palazzo
;
; --- FRAME 1
  .DB 63,63,63,63,63,63,63,63,63,31,31,31,15,7,3,0
  .DB 255,255,255,255,255,255,255,255,143,167,135,255,255,255,255,255
; -- FRAME 2
  .DB 15,15,15,15,15,15,7,7,7,3,3,3,1,0,0,0
  .DB 255,255,255,255,255,255,255,255,143,167,135,255,255,255,127,63
; -- FRAME 3
  .DB 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  .DB 255,255,255,255,255,255,255,255,143,167,135,255,127,63,31,15
; -- FRAME 4
  .DB 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  .DB 15,15,15,15,15,15,15,15,15,15,15,15,15,7,3,1


ANIMAZIONE_PORTA_COLOR:
; PATTERN CHAR COLOR
  .DB 32,176,32,32,176,32,32,176,32,32,176,32,32,176,32,32
  .DB 32,176,32,32,176,32,32,176,43,43,43,32,32,176,32,32

  .DB 32,176,32,32,176,32,32,176,32,32,176,32,32,176,32,32
  .DB 32,176,32,32,176,32,32,176,43,43,43,32,32,176,32,32

  .DB 32,176,32,32,176,32,32,176,32,32,176,32,32,176,32,32
  .DB 32,176,32,32,176,32,32,176,43,43,43,32,32,176,32,32

  .DB 32,176,32,32,176,32,32,176,32,32,176,32,32,176,32,32
  .DB 32,176,32,32,176,32,32,176,32,176,32,32,32,176,32,32
   
SPRDEF:
;--- Slot 0 DX-1 1UP
;--- color 5
  .DB $1E,$1F,$0F,$1F,$3F,$7E,$00,$00
  .DB $0F,$1F,$1F,$33,$33,$00,$00,$00
  .DB $00,$F0,$F8,$CC,$A0,$00,$00,$00
  .DB $80,$E0,$F0,$F8,$F8,$00,$00,$00
;--- color 13
  .DB $00,$00,$00,$00,$00,$01,$1F,$2F
  .DB $40,$80,$80,$0C,$0C,$07,$07,$07
  .DB $00,$00,$00,$00,$40,$A0,$E0,$C0
  .DB $40,$00,$00,$00,$00,$80,$80,$C0
; --- Slot 1 DX-2 1UP
; --- color 5
  .DB $07,$07,$03,$07,$0F,$1F,$00,$00
  .DB $0F,$3F,$3F,$0F,$0F,$00,$00,$00
  .DB $80,$FC,$FE,$F3,$E8,$80,$00,$00
  .DB $E0,$F8,$F8,$F8,$FC,$00,$00,$00
;--- color 13
  .DB $00,$00,$00,$00,$00,$00,$1F,$67
  .DB $80,$00,$40,$60,$00,$1F,$3C,$18
  .DB $00,$00,$00,$00,$10,$68,$F8,$F8
  .DB $10,$00,$06,$06,$00,$F0,$38,$00
;--- Slot 2 SX-1 1UP
;--- color 5
  .DB $00,$0F,$1F,$33,$05,$00,$00,$00
  .DB $01,$07,$0F,$1F,$1F,$00,$00,$00
  .DB $78,$F8,$F0,$F8,$FC,$7E,$00,$00
  .DB $F0,$F8,$F8,$CC,$CC,$00,$00,$00
;--- color 13
  .DB $00,$00,$00,$00,$02,$05,$07,$03
  .DB $02,$00,$00,$00,$00,$01,$01,$03
  .DB $00,$00,$00,$00,$00,$80,$F8,$F4
  .DB $02,$01,$01,$30,$30,$E0,$E0,$E0
; --- Slot 3 SX-2 1UP
; --- color 5
  .DB $01,$3F,$7F,$CF,$17,$01,$00,$00
  .DB $07,$1F,$1F,$1F,$3F,$00,$00,$00
  .DB $E0,$E0,$C0,$E0,$F0,$F8,$00,$00
  .DB $F0,$FC,$FC,$F0,$F0,$00,$00,$00
; --- color 13
  .DB $00,$00,$00,$00,$08,$16,$1F,$1F
  .DB $08,$00,$60,$60,$00,$0F,$1C,$00
  .DB $00,$00,$00,$00,$00,$00,$F8,$E6
  .DB $01,$00,$02,$06,$00,$F8,$3C,$18
; --- Slot 0 DOWN-1 1UP
; ---- color 5
  .DB $00,$01,$07,$0F,$0F,$18,$00,$00
  .DB $38,$7F,$4F,$0F,$1F,$00,$00,$00
  .DB $78,$FE,$FE,$FF,$FF,$13,$01,$00
  .DB $1C,$FE,$F7,$FB,$18,$00,$00,$00
; --- color 13
  .DB $00,$00,$00,$00,$00,$07,$1D,$0F
  .DB $07,$00,$30,$30,$00,$0E,$0E,$1E
  .DB $00,$00,$00,$00,$00,$E0,$B0,$F0
  .DB $E0,$00,$00,$00,$E3,$F0,$00,$00
; --- Slot 1 DOWN-2 1UP
; --- color 5
  .DB $00,$01,$07,$0F,$0F,$18,$00,$00
  .DB $38,$7F,$EF,$DF,$18,$00,$00,$00
  .DB $78,$FE,$FE,$FF,$FF,$13,$01,$00
  .DB $1C,$FE,$F2,$F0,$F8,$00,$00,$00
; --- color 13
  .DB $00,$00,$00,$00,$00,$07,$1D,$0F
  .DB $07,$00,$00,$00,$C7,$0F,$00,$00
  .DB $00,$00,$00,$00,$00,$E0,$B0,$F0
  .DB $E0,$00,$0C,$0C,$00,$70,$70,$78
; --- Slot 2 UP-1  1UP
; --- color 5
  .DB $00,$01,$03,$07,$0F,$07,$00,$1E
  .DB $3F,$7E,$6E,$5F,$1F,$00,$00,$00
  .DB $78,$FE,$FE,$FF,$F3,$E1,$00,$3C
  .DB $7E,$77,$FB,$88,$80,$00,$00,$00
; --- color 13
  .DB $00,$00,$00,$00,$00,$08,$0F,$01
  .DB $00,$01,$01,$00,$00,$07,$07,$0F
  .DB $00,$00,$00,$00,$00,$10,$F0,$C0
  .DB $80,$80,$00,$73,$78,$00,$00,$00
; --- Slot 3 UP-2  1UP
; --- color 5
  .DB $00,$01,$03,$07,$0F,$07,$00,$3E
  .DB $7F,$FE,$DE,$1F,$11,$00,$00,$00
  .DB $78,$FE,$FE,$FF,$F3,$E1,$00,$38
  .DB $7C,$7E,$F6,$FA,$F8,$00,$00,$00
; --- color 13
  .DB $00,$00,$00,$00,$00,$08,$0F,$01
  .DB $00,$01,$01,$C0,$0E,$1E,$00,$00
  .DB $00,$00,$00,$00,$00,$10,$F0,$C0
  .DB $80,$80,$00,$00,$00,$E0,$E0,$F0
;
; --------------------------------------
; --- Slot 0 LIFT TOP
  .DB $00,$00,$00,$00,$00,$00,$00,$00
  .DB $FF,$DA,$DA,$DA,$DA,$CA,$FF,$00
  .DB $00,$00,$00,$00,$00,$00,$00,$00
  .DB $FF,$23,$F7,$77,$F7,$F7,$FF,$00
; --- Slot 0 FURGONE
  .DB $00,$00,$00,$00,$00,$07,$09,$11
  .DB $21,$7F,$FF,$FF,$F3,$6D,$1E,$0C
  .DB $00,$00,$FF,$FF,$FF,$FF,$FF,$FF
  .DB $FF,$FF,$FF,$FF,$F3,$ED,$1E,$0C
; --- Slot 2 LIFT
; ----
  .DB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
  .DB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
  .DB $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
  .DB $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F

; ------------------------------------------------
;  **  DATA SPRITES ANIMATE LIFT  **
; --- FRAME 1 DOOR LIFT
; ---- color 10
  .DB $FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE
  .DB $FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE
  .DB $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
  .DB $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
;3680 ' --- FRAME 2 DOOR LIFT
;3690 ' color 10
  .DB $FC,$FC,$FC,$FC,4FC,$FC,$FC,$FC
  .DB $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC
  .DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F
  .DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F
;3750 ' --- FRAME 3 DOOR LIFT
;3760 ' color 10
  .DB $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8
  .DB $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8
  .DB $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F
  .DB $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F
;3820 ' --- FRAME 4 DOOR LIFT
;3830 ' color 10
  .DB $F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0
  .DB $F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0
  .DB $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
  .DB $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
;3880 ' --- FRAME 5 DOOR LIFT
;3890 ' color 10
  .DB $E0,$E0,$E0,$E0,$E0,$E0,$E0,$E0
  .DB $E0,$E0,$E0,$E0,$E0,$E0,$E0,$E0
  .DB $07,$07,$07,$07,$07,$07,$07,$07
  .DB $07,$07,$07,$07,$07,$07,$07,$07
;3950 ' --- FRAME 6 DOOR LIFT
;3960 ' color 10
  .DB $C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0
  .DB $C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0
  .DB $03,$03,$03,$03,$03,$03,$03,$03
  .DB $03,$03,$03,$03,$03,$03,$03,$03
;4020 ' --- FRAME 7 DOOR LIFT
;4030 ' color 10
  .DB $80,$80,$80,$80,$80,$80,$80,$80
  .DB $80,$80,$80,$80,$80,$80,$80,$80
  .DB $01,$01,$01,$01,$01,$01,$01,$01
  .DB $01,$01,$01,$01,$01,$01,$01,$01  
  
; --- CADUTA 1UP DX
; color 5
  .DB $0F,$0F,$07,$0F,$1F,$3F,$00,$00
  .DB $03,$07,$0F,$0F,$07,$00,$00,$00
  .DB $01,$FA,$FC,$F0,$E0,$80,$00,$00
  .DB $E0,$F8,$FC,$FC,$F8,$00,$00,$00
; color 13
  .DB $00,$00,$00,$00,$80,$80,$8F,$77
  .DB $00,$18,$10,$00,$00,$01,$01,$01
  .DB $00,$00,$00,$00,$10,$68,$F8,$F0
  .DB $16,$06,$00,$00,$00,$E0,$E0,$F0    
  
; --- CADUTA 1UP SX
; color 5
  .DB $80,$5F,$3F,$0F,$07,$01,$00,$00
  .DB $07,$1F,$3F,$3F,$1F,$00,$00,$00
  .DB $F0,$F0,$E0,$F0,$F8,$FC,$00,$00
  .DB $C0,$E0,$F0,$F0,$E0,$00,$00,$00
; color 13
  .DB $00,$00,$00,$00,$08,$16,$1F,$0F
  .DB $68,$60,$00,$00,$00,$07,$07,$0F
  .DB $00,$00,$00,$00,$01,$01,$F1,$EE
  .DB $00,$18,$08,$00,$00,$80,$80,$80
;
; --- MORTE 1UP FRAME-1
; color 5
  .DB $0F,$0F,$07,$0F,$1F,$3F,$00,$00
  .DB $03,$07,$0C,$0C,$00,$00,$00,$00
  .DB $00,$F8,$FC,$F2,$E0,$80,$00,$00
  .DB $E0,$F8,$FC,$FC,$00,$00,$00,$00
; color 13
  .DB $00,$00,$00,$00,$00,$00,$0F,$17
  .DB $20,$20,$13,$03,$00,$07,$07,$06
  .DB $00,$00,$00,$00,$10,$68,$F8,$F0
  .DB $10,$00,$00,$00,$F0,$F0,$F0,$60
;
; --- MORTE 1UP FRAME-2
; color 5
  .DB $00,$00,$00,$10,$30,$60,$68,$70
  .DB $71,$79,$F9,$F9,$F9,$D8,$18,$08
  .DB $00,$00,$00,$00,$00,$00,$60,$E0
  .DB $E0,$E0,$E0,$E0,$E0,$E0,$70,$30
; color 13
  .DB $00,$00,$00,$00,$00,$00,$06,$0B
  .DB $0E,$06,$06,$06,$06,$04,$02,$01
  .DB $00,$00,$00,$02,$66,$66,$0E,$1C
  .DB $19,$13,$1F,$1F,$1F,$1E,$00,$80
;
; --- MORTE 1UP FRAME-3
; color 5
  .DB $00,$00,$00,$00,$00,$00,$10,$30
  .DB $60,$68,$70,$71,$79,$F9,$F9,$F9
  .DB $00,$00,$00,$00,$00,$00,$00,$00
  .DB $00,$40,$C0,$E0,$E0,$E0,$E0,$E0
; color 13
  .DB $00,$00,$00,$00,$00,$00,$00,$00
  .DB $00,$06,$0B,$0E,$06,$06,$06,$06
  .DB $00,$00,$00,$00,$00,$00,$00,$00
  .DB $00,$30,$31,$03,$07,$1F,$1F,$1F


endProgram:


 .end
